Index: issm/trunk/src/m/contrib/morlighem/modeldata/interpIBCSO2.m
===================================================================
--- issm/trunk/src/m/contrib/morlighem/modeldata/interpIBCSO2.m	(revision 27232)
+++ issm/trunk/src/m/contrib/morlighem/modeldata/interpIBCSO2.m	(revision 27232)
@@ -0,0 +1,24 @@
+function [bedout sid] = interpIBCSO2(X,Y),
+
+%read data
+switch (oshostname()),
+	case {'totten'}
+		ncpath='/totten_1/ModelData/Antarctica/IBCSO2/IBCSO_v2_bed.nc';
+		sidpath='/totten_1/ModelData/Antarctica/IBCSO2/IBCSO_v2_TID.nc';
+	otherwise
+		error('hostname not supported yet');
+end
+
+disp('   -- IBCSOv2: loading bathymetry');
+xdata = double(ncread(ncpath,'x'));
+ydata = double(ncread(ncpath,'y'));
+data  = double(ncread(ncpath,'z'))';
+disp('   -- IBCSOv2: interpolating bed');
+bedout = InterpFromGrid(xdata,ydata,data,double(X),double(Y));
+
+if nargout==2,
+	disp('   -- IBCSOv2: bathymetry sid');
+	data  = ncread(sidpath,'tid')';
+	disp('   -- IBCSOv2: interpolating sids');
+	sid = InterpFromGrid(xdata,ydata,data,double(X),double(Y),'nearest');
+end
Index: issm/trunk/src/m/coordsystems/epsg2proj.py
===================================================================
--- issm/trunk/src/m/coordsystems/epsg2proj.py	(revision 27035)
+++ issm/trunk/src/m/coordsystems/epsg2proj.py	(revision 27232)
@@ -2,6 +2,6 @@
 
 
-def epsg2proj(epsg): #{{{
-    """EPSG2PROJ - uses gdalsrsinfo to provide PROJ.4 compatible string 
+def epsg2proj(epsg):  #{{{
+    """EPSG2PROJ - uses gdalsrsinfo to provide PROJ.4 compatible string
     from EPSG code
 
@@ -21,5 +21,5 @@
     #First, get GDAL version
     subproc_args = "gdalsrsinfo --version | awk '{print $2}' | cut -d '.' -f1"
-    subproc = subprocess.Popen(subproc_args, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+    subproc = subprocess.Popen(subproc_args, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, universal_newlines=True)
     outs, errs = subproc.communicate()
     if errs != '':
@@ -29,5 +29,5 @@
 
     subproc_args = "gdalsrsinfo epsg:{} | command grep PROJ.4 | tr -d '\n' | sed 's/PROJ.4 : //'".format(epsg)
-    subproc = subprocess.Popen(subproc_args, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+    subproc = subprocess.Popen(subproc_args, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, universal_newlines=True)
     outs, errs = subproc.communicate()
     if errs != '':
@@ -35,5 +35,5 @@
 
     if version_major == 1:
-        r = r[1:-1]
+        outs = outs[1:-1]
 
     return outs
Index: issm/trunk/src/m/coordsystems/gdaltransform.py
===================================================================
--- issm/trunk/src/m/coordsystems/gdaltransform.py	(revision 27035)
+++ issm/trunk/src/m/coordsystems/gdaltransform.py	(revision 27232)
@@ -46,5 +46,5 @@
 
     subproc_args = shlex.split("gdaltransform -s_srs '{}' -t_srs '{}'".format(proj_in, proj_out))
-    subproc = subprocess.Popen(subproc_args, bufsize=-1, stdin=file_in, stdout=file_out, stderr=subprocess.PIPE, close_fds=True)
+    subproc = subprocess.Popen(subproc_args, bufsize=-1, stdin=file_in, stdout=file_out, stderr=subprocess.PIPE, close_fds=True, universal_newlines=True)
     outs, errs = subproc.communicate()
     if errs != '':
Index: issm/trunk/src/m/coordsystems/gmtmaskparallel.m
===================================================================
--- issm/trunk/src/m/coordsystems/gmtmaskparallel.m	(revision 27035)
+++ issm/trunk/src/m/coordsystems/gmtmaskparallel.m	(revision 27232)
@@ -4,4 +4,7 @@
 %   Usage:
 %      mask.ocean = gmtmaskparallel(md.mesh.lat,md.mesh.long,8);
+%
+%   TODO:
+%   - Remove hardcoded paths and instead find paths dynamically
 %
 
@@ -39,5 +42,5 @@
 	fid=fopen('xjobs.script','w');
 	for i=1:length(nnv)-1,
-		fprintf(fid,'%s gmtselect ./all_vertices%i.txt -h0 -Df -R0/360/-90/90  -A0 -JQ180/200 -Nk/s/s/k/s > ./oce_vertices%i.txt\n',gmtpath,i,i);
+		fprintf(fid,'%s gmt select ./all_vertices%i.txt -h0 -Df -R0/360/-90/90  -A0 -JQ180/200 -Nk/s/s/k/s > ./oce_vertices%i.txt\n',gmtpath,i,i);
 	end
 	fclose(fid);
Index: issm/trunk/src/m/coordsystems/ll2xy.m
===================================================================
--- issm/trunk/src/m/coordsystems/ll2xy.m	(revision 27035)
+++ issm/trunk/src/m/coordsystems/ll2xy.m	(revision 27232)
@@ -44,7 +44,14 @@
 	disp('Calling CoordTransform instead, make sure to change your MATLAB script');
 	if sgn==+1
-		assert(delta==45); assert(slat ==70);
-		[x y]=CoordTransform(lat,lon,'EPSG:4326','EPSG:3413');
-		return;
+		if delta==45 && slat==70      %BedMachine
+			[x y]=CoordTransform(lat,lon,'EPSG:4326','EPSG:3413'); return;
+		elseif delta==0 && slat==75   %IBCAO
+			[x y]=CoordTransform(lat,lon,'EPSG:4326','EPSG:3996'); return;
+		elseif delta==39 && slat==71  %Bamber
+			Bamber_proj = '+proj=stere +lat_0=90 +lat_ts=71 +lon_0=-39 +k=1 +x_0=0 +y_0=0 +ellps=WGS84 +datum=WGS84 +units=m +no_defs';
+			[x y]=CoordTransform(lat,lon,'EPSG:4326',Bamber_proj); return;
+		else
+			error('not supported yet');
+		end
 	else
 		assert(delta==0); assert(slat ==71);
Index: issm/trunk/src/m/coordsystems/xy2ll.m
===================================================================
--- issm/trunk/src/m/coordsystems/xy2ll.m	(revision 27035)
+++ issm/trunk/src/m/coordsystems/xy2ll.m	(revision 27232)
@@ -40,7 +40,14 @@
 	disp('Calling CoordTransform instead, make sure to change your MATLAB script');
 	if sgn==+1
-		assert(delta==45); assert(slat ==70);
-		[lat lon]=CoordTransform(x, y,'EPSG:3413','EPSG:4326');
-		return;
+		if delta==45 && slat==70      %BedMachine
+			[lat lon]=CoordTransform(x, y,'EPSG:3413','EPSG:4326'); return;
+		elseif delta==0 && slat==75   %IBCAO
+			[lat lon]=CoordTransform(x, y,'EPSG:3996','EPSG:4326'); return;
+		elseif delta==39 && slat==71  %Bamber
+			Bamber_proj = '+proj=stere +lat_0=90 +lat_ts=71 +lon_0=-39 +k=1 +x_0=0 +y_0=0 +ellps=WGS84 +datum=WGS84 +units=m +no_defs';
+			[lat lon]=CoordTransform(x, y, Bamber_proj, 'EPSG:4326'); return;
+		else
+			error('not supported yet');
+		end
 	else
 		assert(delta==0); assert(slat ==71);
Index: issm/trunk/src/m/dev/devpath.py
===================================================================
--- issm/trunk/src/m/dev/devpath.py	(revision 27035)
+++ issm/trunk/src/m/dev/devpath.py	(revision 27232)
@@ -37,5 +37,8 @@
         print('Warning: devpath.py: cluster settings should be in {}'.format(jpl_path))
 
-from runme import runme  #first because plotmodel may fail
+try: # Avoid circular import
+    from runme import runme  # First, because plotmodel may fail
+except:
+    pass
 from plotmodel import plotmodel
 
Index: issm/trunk/src/m/mesh/ComputeHessian.py
===================================================================
--- issm/trunk/src/m/mesh/ComputeHessian.py	(revision 27035)
+++ issm/trunk/src/m/mesh/ComputeHessian.py	(revision 27232)
@@ -39,9 +39,9 @@
 
     #compute weights that hold the volume of all the element holding the node i
-    weights = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile(areas, (3, 1)), numberofnodes, 1)
+    weights = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile(areas, (1, 3)), numberofnodes, 1)
 
     #compute field on nodes if on elements
     if np.size(field, axis=0) == numberofelements:
-        field = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile(areas * field, (3, 1)), numberofnodes, 1) / weights
+        field = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile(areas * field, (1, 3)), numberofnodes, 1) / weights
 
     #Compute gradient for each element
@@ -50,6 +50,6 @@
 
     #Compute gradient for each node (average of the elements around)
-    gradx = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * grad_elx), (3, 1)), numberofnodes, 1)
-    grady = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * grad_ely), (3, 1)), numberofnodes, 1)
+    gradx = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * grad_elx), (1, 3)), numberofnodes, 1)
+    grady = m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * grad_ely), (1, 3)), numberofnodes, 1)
     gradx = gradx / weights
     grady = grady / weights
@@ -60,7 +60,7 @@
     if m.strcmpi(type, 'node'):
         #Compute Hessian on the nodes (average of the elements around)
-        hessian = np.hstack((m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * hessian[:, 0]), (3, 1)), numberofnodes, 1) / weights,
-                             m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * hessian[:, 1]), (3, 1)), numberofnodes, 1) / weights,
-                             m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * hessian[:, 2]), (3, 1)), numberofnodes, 1) / weights))
+        hessian = np.hstack((m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * hessian[:, 0]), (1, 3)), numberofnodes, 1) / weights,
+                             m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * hessian[:, 1]), (1, 3)), numberofnodes, 1) / weights,
+                             m.sparse(line, np.ones((linesize, 1), dtype=int), np.tile((areas * hessian[:, 2]), (1, 3)), numberofnodes, 1) / weights))
 
     return hessian
Index: issm/trunk/src/m/mesh/bamg.py
===================================================================
--- issm/trunk/src/m/mesh/bamg.py	(revision 27035)
+++ issm/trunk/src/m/mesh/bamg.py	(revision 27232)
@@ -23,92 +23,92 @@
     Available options (for more details see ISSM website http://issm.jpl.nasa.gov/):
 
-    - domain :                              followed by an ARGUS file that 
+    - domain :                              followed by an ARGUS file that
                                             prescribes the domain outline
-    - holes :                               followed by an ARGUS file that 
+    - holes :                               followed by an ARGUS file that
                                             prescribes the holes
-    - subdomains :                          followed by an ARGUS file that 
-                                            prescribes the list of subdomains 
+    - subdomains :                          followed by an ARGUS file that
+                                            prescribes the list of subdomains
                                             (that need to be inside domain)
 
-    - hmin :                                minimum edge length (default is 
+    - hmin :                                minimum edge length (default is
                                             1.0e-100)
-    - hmax :                                maximum edge length (default is 
+    - hmax :                                maximum edge length (default is
                                             1.0e100)
-    - hVertices :                           imposed edge length for each vertex 
+    - hVertices :                           imposed edge length for each vertex
                                             (geometry or mesh)
-    - hminVertices :                        minimum edge length for each vertex 
+    - hminVertices :                        minimum edge length for each vertex
                                             (mesh)
-    - hmaxVertices :                        maximum edge length for each vertex 
+    - hmaxVertices :                        maximum edge length for each vertex
                                             (mesh)
 
-    - anisomax :                            maximum ratio between the smallest 
-                                            and largest edges (default is 
+    - anisomax :                            maximum ratio between the smallest
+                                            and largest edges (default is
                                             1.0e30)
-    - coeff :                               coefficient applied to the metric 
-                                            (2 -> twice as many elements, 
+    - coeff :                               coefficient applied to the metric
+                                            (2 -> twice as many elements,
                                             default is 1)
-    - cutoff :                              scalar used to compute the metric 
+    - cutoff :                              scalar used to compute the metric
                                             when metric type 2 or 3 are applied
-    - err :                                 error used to generate the metric 
+    - err :                                 error used to generate the metric
                                             from a field
     - errg :                                geometric error (default is 0.1)
-    - field :                               field of the model that will be 
-                                            used to compute the metric to apply 
-                                            several fields, use one column per 
+    - field :                               field of the model that will be
+                                            used to compute the metric to apply
+                                            several fields, use one column per
                                             field
-    - gradation :                           maximum ratio between two adjacent 
+    - gradation :                           maximum ratio between two adjacent
                                             edges
-    - Hessiantype :                         0 -> use double P2 projection 
+    - Hessiantype :                         0 -> use double P2 projection
                                             (default)
                                             1 -> use Green formula
-    - KeepVertices :                        try to keep initial vertices when 
-                                            adaptation is done on an existing 
+    - KeepVertices :                        try to keep initial vertices when
+                                            adaptation is done on an existing
                                             mesh (default 1)
-    - NoBoundaryRefinement :                do not refine boundary, only follow 
-                                            contour provided (default 0). Allow 
-                                            subdomain boundary refinement 
+    - NoBoundaryRefinement :                do not refine boundary, only follow
+                                            contour provided (default 0). Allow
+                                            subdomain boundary refinement
                                             though
-    - NoBoundaryRefinementAllBoundaries :   do not refine boundary, only follow 
+    - NoBoundaryRefinementAllBoundaries :   do not refine boundary, only follow
                                             contour provided (default 0)
-    - maxnbv :                              maximum number of vertices used to 
+    - maxnbv :                              maximum number of vertices used to
                                             allocate memory (default is 1.0e6)
-    - maxsubdiv :                           maximum subdivision of exisiting 
+    - maxsubdiv :                           maximum subdivision of exisiting
                                             elements (default is 10)
-    - metric :                              matrix (numberofnodes x 3) used as 
+    - metric :                              matrix (numberofnodes x 3) used as
                                             a metric
-    - Metrictype :                          1 -> absolute error 
+    - Metrictype :                          1 -> absolute error
                                             c/(err coeff^2) * Abs(H) (default)
-                                            2 -> relative error 
-                                            c / (err coeff^2) * Abs(H) / 
+                                            2 -> relative error
+                                            c / (err coeff^2) * Abs(H) /
                                             max(s, cutoff * max(s))
-                                            3 -> rescaled absolute error 
-                                            c / (err coeff^2) * Abs(H) / 
+                                            3 -> rescaled absolute error
+                                            c / (err coeff^2) * Abs(H) /
                                             (smax - smin)
-    - nbjacoby :                            correction used by Hessiantype = 1 
+    - nbjacoby :                            correction used by Hessiantype = 1
                                             (default is 1)
-    - nbsmooth :                            number of metric smoothing 
+    - nbsmooth :                            number of metric smoothing
                                             procedure (default is 3)
-    - omega :                               relaxation parameter of the 
-                                            smoothing procedure (default is 
+    - omega :                               relaxation parameter of the
+                                            smoothing procedure (default is
                                             1.8)
-    - power :                               power applied to the metric 
+    - power :                               power applied to the metric
                                             (default is 1)
-    - splitcorners :                        split triangles which have 3 
-                                            vertices on the outline (default is 
+    - splitcorners :                        split triangles which have 3
+                                            vertices on the outline (default is
                                             1)
     - verbose :                             level of verbosity (default is 1)
 
-    - rifts :                               followed by an ARGUS file that 
+    - rifts :                               followed by an ARGUS file that
                                             prescribes the rifts
-    - toltip :                              tolerance to move tip on an 
-                                            existing point of the domain 
+    - toltip :                              tolerance to move tip on an
+                                            existing point of the domain
                                             outline
-    - tracks :                              followed by an ARGUS file that 
-                                            prescribes the tracks that the mesh 
+    - tracks :                              followed by an ARGUS file that
+                                            prescribes the tracks that the mesh
                                             will stick to
-    - RequiredVertices :                    mesh vertices that are required. 
+    - RequiredVertices :                    mesh vertices that are required.
                                             [x, y, ref]; ref is optional
-    - tol :                                 if the distance between 2 points of 
-                                            the domain outline is less than 
+    - tol :                                 if the distance between 2 points of
+                                            the domain outline is less than
                                             tol, they will be merged
 
@@ -250,9 +250,8 @@
 
             # Flag how many edges we have now, that way we know which edges
-            # belong to the subdomain. Will be used later fo required edges 
+            # belong to the subdomain. Will be used later fo required edges
             # if NoBoundaryRefinement equals 1.
             new_edge_length = len(bamg_geometry.Edges)
-            edges_required = range((edge_length + 1), (new_edge_length + 1)) # NOTE: Upper bound of range is non-inclusive (compare to src/m/mesh/bamg.m)
-
+            edges_required = np.asarray(range((edge_length + 1), (new_edge_length + 1)))  # NOTE: Upper bound of range is non-inclusive (compare to src/m/mesh/bamg.m)
             if i: # NOTE: same as `if i > 0` (MATLAB is `if i > 1`)
                 bamg_geometry.SubDomains = np.vstack((bamg_geometry.SubDomains, [2, count + 1, 1, -subdomain_ref]))
@@ -445,5 +444,5 @@
                                     np.array([[count, count + 1, 2]]),
                                     np.hstack((
-                                        np.arange(count + 1, count + nods).reshape(-1, ), 
+                                        np.arange(count + 1, count + nods).reshape(-1, ),
                                         np.arange(count + 2, count + nods + 1).reshape(-1, ),
                                         (1 + i) * np.ones((nods - 1, 1))
@@ -455,5 +454,5 @@
                     nods = rift[i]['nods'] - 1
                     bamg_geometry.Vertices = np.vstack((
-                        bamg_geometry.Vertices, 
+                        bamg_geometry.Vertices,
                         np.hstack((
                             rift[i]['x'][:],
Index: issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m
===================================================================
--- issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m	(revision 27035)
+++ issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m	(revision 27232)
@@ -15,8 +15,39 @@
 %      md.mesh=gmshplanet('radius',6000,'resolution',100);
 
+	%Find path to gmsh
+	paths = {
+		[getenv('ISSM_EXT_DIR') '/shared/gmsh/install/bin/gmsh'],...
+		[getenv('ISSM_EXT_DIR') '/static/gmsh/install/bin/gmsh'],...
+		[getenv('ISSM_EXT_DIR') '/gmsh/install/bin/gmsh'],...
+		[issmdir() 'externalpackages/gmsh/install/bin/gmsh'],...
+		[issmdir() 'bin/gmsh'],...
+		['/usr/bin/gmsh']...
+	};
+	gmshpath = '';
+	for i=paths
+		if exist(i{1},'file'),
+			gmshpath = i{1};
+			break;
+		end
+	end
+	if isempty(gmshpath),
+		error('Gmsh not found, make sure it is properly installed');
+	end
+
 	% Get Gmsh version
 	[s,r]=system(['gmsh -info 2>&1 | command grep ''Version'' | sed -e ''s/Version[[:blank:]]*:[[:blank:]]//'' | cut -d ''.'' -f1']);
 	if s~=0,
 		error(r);
+	elseif isempty(r),
+		% If this function is called from one of our distributable packages, we 
+		% need to do a bit more to find the Gmsh executable
+		[filepath,name,ext]=fileparts(which('gmsh.'));
+		setenv('PATH',[filepath ':' getenv('PATH')]);
+		[s,r]=system(['gmsh -info 2>&1 | command grep ''Version'' | sed -e ''s/Version[[:blank:]]*:[[:blank:]]//'' | cut -d ''.'' -f1']);
+		if s~=0,
+			error(r);
+		elseif isempty(r),
+			error('gmshplanet: Gmsh executable not found!');
+		end
 	end
 	gmshmajorversion=str2num(r);
@@ -40,9 +71,9 @@
 
 	% NOTE:
-	% - The default format in Gmsh 3 is "msh2". Rather than conditionally 
-	% modifying our parsing scheme for Gmsh 4, for now, we simply set the 
+	% - The default format in Gmsh 3 is "msh2". Rather than conditionally
+	% modifying our parsing scheme for Gmsh 4, for now, we simply set the
 	% 'Mesh.MshFileVersion' option.
-	% - Decreasing the value of the 'Mesh.RandomFactor' option leads to an 
-	% equal number of nodes and elements being produced under macOS and Linux 
+	% - Decreasing the value of the 'Mesh.RandomFactor' option leads to an
+	% equal number of nodes and elements being produced under macOS and Linux
 	% at certain resolutions using certain meshing algorithms.
 	%
@@ -131,4 +162,9 @@
 
 	% Call gmsh
+	%
+	% NOTE: The default format in Gmsh 3 is "msh2". Rather than conditionally
+	%		modifying our parsing scheme for Gmsh 4, for now, we simply set the
+	%		"-format" option.
+	%
 	if  exist(options,'refine'),
 		system(['gmsh -2 sphere.geo -bgm sphere.pos']);
@@ -184,9 +220,9 @@
 	%}}}
 
-	%a little technicality here. the mesh generate is not exactly on the 
-	%sphere. we create lat,long coordinates, and reproject on an exact sphere. 
+	%a little technicality here. the mesh generate is not exactly on the
+	%sphere. we create lat,long coordinates, and reproject on an exact sphere.
 	mesh.r=sqrt(mesh.x.^2+mesh.y.^2+mesh.z.^2);
 
-	%make sure we don't have south and north pole: 
+	%make sure we don't have south and north pole:
 	pos=find(mesh.x==0 & mesh.y==0);
 	mesh.lat = asind(mesh.z./mesh.r);
Index: issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.py
===================================================================
--- issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.py	(revision 27035)
+++ issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.py	(revision 27232)
@@ -1,6 +1,4 @@
 import subprocess
-
 import numpy as np
-
 from MatlabFuncs import *
 from mesh3dsurface import *
@@ -26,8 +24,11 @@
     # Get Gmsh version
     subproc_args = 'gmsh -info 2>&1 | command grep \'Version\' | sed -e \'s/Version[[:blank:]]*:[[:blank:]]//\' | cut -d \'.\' -f1'
-    subproc = subprocess.Popen(subproc_args, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+    subproc = subprocess.Popen(subproc_args, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, universal_newlines=True)
     outs, errs = subproc.communicate()
-
-    if ((not isinstance(errs,bytes)) & (errs != '')) or (isinstance(errs,bytes) & (errs.decode() != '')):
+    try:
+        strErrs = errs.decode()
+    except AttributeError:  #this is not a byte variable, let's assume string
+        strErrs = errs
+    if strErrs != '':
         raise Exception('gmshplanet: call to gmsh failed: {}'.format(errs))
     gmshmajorversion = int(outs)
@@ -51,9 +52,9 @@
     #
     # NOTE:
-    # - The default format in Gmsh 3 is "msh2". Rather than conditionally 
-    # modifying our parsing scheme for Gmsh 4, for now, we simply set the 
+    # - The default format in Gmsh 3 is "msh2". Rather than conditionally
+    # modifying our parsing scheme for Gmsh 4, for now, we simply set the
     # 'Mesh.MshFileVersion' option.
-    # - Decreasing the value of the 'Mesh.RandomFactor' option leads to an 
-    # equal number of nodes and elements being produced under macOS and Linux 
+    # - Decreasing the value of the 'Mesh.RandomFactor' option leads to an
+    # equal number of nodes and elements being produced under macOS and Linux
     # at certain resolutions using certain meshing algorithms.
     #
@@ -126,12 +127,18 @@
         for i in range(meshini.numberofelements):
             fid.write('ST(%g,%g,%g,%g,%g,%g,%g,%g,%g){%g,%g,%g};\n'
-                % (meshini.x[meshini.elements[i, 0]-1], meshini.y[meshini.elements[i, 0]-1], meshini.z[meshini.elements[i, 0]-1],
-                meshini.x[meshini.elements[i, 1]-1], meshini.y[meshini.elements[i, 1]-1], meshini.z[meshini.elements[i, 1]-1],
-                meshini.x[meshini.elements[i, 2]-1], meshini.y[meshini.elements[i, 2]-1], meshini.z[meshini.elements[i, 2]-1],
-                metric[meshini.elements[i, 0]-1], metric[meshini.elements[i, 1]-1], metric[meshini.elements[i, 2]-1]))
+                      % (meshini.x[meshini.elements[i, 0] - 1], meshini.y[meshini.elements[i, 0] - 1], meshini.z[meshini.elements[i, 0] - 1],
+                         meshini.x[meshini.elements[i, 1] - 1], meshini.y[meshini.elements[i, 1] - 1], meshini.z[meshini.elements[i, 1] - 1],
+                         meshini.x[meshini.elements[i, 2] - 1], meshini.y[meshini.elements[i, 2] - 1], meshini.z[meshini.elements[i, 2] - 1],
+                         metric[meshini.elements[i, 0] - 1], metric[meshini.elements[i, 1] - 1], metric[meshini.elements[i, 2] - 1]))
         fid.write('};\n')
         fid.close()
         #}}}
 
+    # Call gmsh
+    #
+    # NOTE: The default format in Gmsh 3 is "msh2". Rather than conditionally
+    #       modifying our parsing scheme for Gmsh 4, for now, we simply set the
+    #       "-format" option.
+    #
     if options.exist('refine'):
         subprocess.call('gmsh -2 sphere.geo -bgm sphere.pos', shell=True)
@@ -187,5 +194,5 @@
     #}}}
 
-    # A little technicality here. The mesh is not exactly on the sphere. We 
+    # A little technicality here. The mesh is not exactly on the sphere. We
     # create lat,long coordiantes, and reproject onto an exact sphere.
     mesh.r = np.sqrt(mesh.x ** 2 + mesh.y ** 2 + mesh.z ** 2)
Index: issm/trunk/src/m/modules/CoordTransform.m
===================================================================
--- issm/trunk/src/m/modules/CoordTransform.m	(revision 27035)
+++ issm/trunk/src/m/modules/CoordTransform.m	(revision 27232)
@@ -31,4 +31,12 @@
 end
 
+% If this function is called from within one of our distributable packages, set 
+% the 'PROJ_LIB' environment variable so that the PROJ binary can find the 
+% assets it needs
+whatproj=what('share/proj');
+if ~isempty(whatproj) && isdir(whatproj.path)
+	setenv('PROJ_LIB', whatproj.path);
+end
+
 % Call mex module
 [xout, yout] = CoordTransform_matlab(xin,yin,projin,projout);
Index: issm/trunk/src/m/parameterization/setflowequation.m
===================================================================
--- issm/trunk/src/m/parameterization/setflowequation.m	(revision 27035)
+++ issm/trunk/src/m/parameterization/setflowequation.m	(revision 27232)
@@ -55,5 +55,5 @@
 %check that each element has at least one flag
 if any(SIAflag+SSAflag+HOflag+L1L2flag+MOLHOflag+FSflag==0),
-	error('elements type not assigned, supported models are ''SIA'',''SSA'',''HO'' and ''FS''')
+	error('elements type not assigned, supported models are ''SIA'',''SSA'',''HO'',''MOLHO'' and ''FS''')
 end
 
Index: issm/trunk/src/m/plot/applyoptions.py
===================================================================
--- issm/trunk/src/m/plot/applyoptions.py	(revision 27035)
+++ issm/trunk/src/m/plot/applyoptions.py	(revision 27232)
@@ -11,4 +11,5 @@
 from plot_contour import plot_contour
 from plot_streamlines import plot_streamlines
+from plot_edgeoverlay import plot_edgeoverlay
 
 
@@ -33,5 +34,5 @@
     fontsize = options.getfieldvalue('fontsize', 8)
     fontweight = options.getfieldvalue('fontweight', 'normal')
-    fontfamily = options.getfieldvalue('fontfamily', 'sans - serif')
+    fontfamily = options.getfieldvalue('fontfamily', 'sans-serif')
     font = {
         'fontsize': fontsize,
@@ -156,12 +157,9 @@
     # {{{ ShowBasins TODO
     # }}}
-    # {{{ clim
-    if options.exist('clim'):
-        lims = options.getfieldvalue('clim')
-        assert len(lims) == 2, 'error, clim should be passed as a list of length 2'
-    elif options.exist('caxis'):
+    # {{{ caxis
+    if options.exist('caxis'):
         lims = options.getfieldvalue('caxis')
         assert len(lims) == 2, 'error, caxis should be passed as a list of length 2'
-        options.addfielddefault('clim', lims)
+        options.addfielddefault('caxis', lims)
     else:
         if len(data) > 0:
@@ -188,13 +186,10 @@
     if options.exist('cmap_set_under'):
         cbar_extend += 2
-    # }}}
-    # {{{ contours
-    if options.exist('contourlevels'):
-        plot_contour(md, data, options, ax)
-    # }}}
-    # {{{ wrapping TODO
-    # }}}
-    # {{{ colorbar
-    if options.getfieldvalue('colorbar', 1) == 1:
+
+    # }}}
+    # {{{ colorbar extension
+    if options.exist('cbar_extend'):
+        extend = options.getfieldvalue('cbar_extend', 'neither')
+    else:
         if cbar_extend == 0:
             extend = 'neither'
@@ -205,5 +200,19 @@
         elif cbar_extend == 3:
             extend = 'both'
-
+        options.addfielddefault('cbar_extend', extend)
+    # }}}
+    # {{{ contours
+    if options.exist('contourlevels'):
+        plot_contour(md, data, options, ax)
+    # }}}
+    # {{{ edgeoverlay
+    if options.exist('edgeoverlay'):
+        edgedata = options.getfieldvalue('edgeoverlay')
+        plot_edgeoverlay(md, edgedata, options, ax)
+    # }}}
+    # {{{ wrapping TODO
+    # }}}
+    # {{{ colorbar
+    if options.getfieldvalue('colorbar', 1) == 1:
         cb = mpl.colorbar.ColorbarBase(ax.cax, cmap=cmap, norm=norm, extend=extend)
         if options.exist('alpha'):
